/******************************************************************************
 *            g_creation_affich_coups.c                                       *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

/* création et affichage des coups joués */

#include "g_creation_affich_coups.h"
void
gnavigation_debut_partie (GtkButton * bouton, gpointer donnee)
{
  register gint z;
  GtkTreeIter iter;
	GtkWidget *cadre_partie;
	cadre_partie=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "cadre_partie"));
	GtkListStore *coup_affiche;
	coup_affiche=(GtkListStore*)
								(gtk_data_list_get_by_name(widget_list, "coup affiche"));
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *bouton_debut;
	bouton_debut=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton debut"));
	GtkWidget *bouton_recul;
	bouton_recul=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton recul"));
	GtkWidget *bouton_avance;
	bouton_avance=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton avance"));
	GtkWidget *bouton_dernier_coup;
	bouton_dernier_coup=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton dernier coup"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

  // Il faut donner au tableaux des pièces et de l'échiquier
  // Les valeurs du premier coup.
  for (z = 0; z < 33; z++)
    {
      table_piece[z] = tab_sauve_partie[0].table_piece[z];
    }

  for (z = 0; z < 144; z++)
    {
      echiquier[z] = tab_sauve_partie[0].echiquier[z];
    }
  // On redessine l'échiquier
  gtk_widget_queue_draw (Zone_dessin);

  // On désactive le bouton de retour en début de partie puisque c'est fait!
  gtk_widget_set_sensitive (bouton_debut, FALSE);
  gtk_widget_set_sensitive (bouton_recul, FALSE);

  // On active maintenant les 2 autres boutons de navigation
  gtk_widget_set_sensitive (bouton_avance, TRUE);
  gtk_widget_set_sensitive (bouton_dernier_coup, TRUE);

  // Positionnement de l'ascenceur sur le 1er coup et sélection de celui-ci.
  if (gtk_tree_model_get_iter_first (GTK_TREE_MODEL (coup_affiche), &iter))
    {
      gtk_tree_view_set_cursor_on_cell (GTK_TREE_VIEW (cadre_partie),
					gtk_tree_model_get_path
					(GTK_TREE_MODEL (coup_affiche),
					 &iter), NULL, NULL, FALSE);
      gtk_tree_selection_select_iter (gtk_tree_view_get_selection
				      (GTK_TREE_VIEW (cadre_partie)), &iter);
    }

  g_position_courante_navigation = 1;

  // On interdit la possibilité de jouer un coup si la position
  // ainsi que d'annuler un coup
  // actuellement sélectionnée n'est pas la dernière.
  // On désactive le widget de l'échiquier
  gtk_widget_set_sensitive (Zone_dessin, FALSE);
			gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), FALSE);
}

void
gnavigation_recul (GtkButton * bouton, gpointer donnee)
{
  register gint z;
  GtkTreeIter iter;
  gint position = 1;
	gint compteur = 1;
  gchar *blancs;
  gchar *noirs;
	GtkWidget *cadre_partie;
	cadre_partie=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "cadre_partie"));
	GtkListStore *coup_affiche;
	coup_affiche=(GtkListStore*)
								(gtk_data_list_get_by_name(widget_list, "coup affiche"));
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *bouton_debut;
	bouton_debut=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton debut"));
	GtkWidget *bouton_recul;
	bouton_recul=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton recul"));
	GtkWidget *bouton_avance;
	bouton_avance=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton avance"));
	GtkWidget *bouton_dernier_coup;
	bouton_dernier_coup=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton dernier coup"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

  // On récupère l'iter actuellement pointé dans "iter"
  if (gtk_tree_selection_get_selected
      (gtk_tree_view_get_selection (GTK_TREE_VIEW (cadre_partie)), NULL, &iter))
	{
		// On récupère la numéro du coup dans "position"
		gtk_tree_model_get (GTK_TREE_MODEL (coup_affiche), &iter, 0, &position,
			1, &blancs, 2, &noirs, -1);

		// On va se placer maintenant une ligne avant celle sélectionnée si elle
		// existe.
		if (g_position_courante_navigation > 1)
		{
	  	if (g_position_courante_navigation % 2 == 0)
	    {
	      gtk_tree_model_get_iter_first (GTK_TREE_MODEL (coup_affiche),&iter);
				gtk_tree_selection_select_iter (gtk_tree_view_get_selection
				      													(GTK_TREE_VIEW (cadre_partie)), &iter);
	      while (compteur < position-1)
				{
					if (gtk_tree_model_iter_next(GTK_TREE_MODEL(coup_affiche), &iter))
					{
						gtk_tree_selection_select_iter (gtk_tree_view_get_selection
																					(GTK_TREE_VIEW(cadre_partie)), &iter);
					}
					compteur ++;
				}
				gtk_tree_view_set_cursor_on_cell (GTK_TREE_VIEW(cadre_partie),
						    gtk_tree_model_get_path(GTK_TREE_MODEL(coup_affiche), &iter),
						    																						NULL, NULL, FALSE);
	    }
		}
	}

  // Il faut donner au tableaux des pièces et de l'échiquier
  // Les valeurs du coup précédent.
  for (z = 0; z < 33; z++)
	{
		table_piece[z] =
					tab_sauve_partie[g_position_courante_navigation - 2].table_piece[z];
	}

  for (z = 0; z < 144; z++)
	{
		echiquier[z] =
							tab_sauve_partie[g_position_courante_navigation - 2].echiquier[z];
	}

  if (g_position_courante_navigation != 1)
    g_position_courante_navigation--;

  // On redessine l'échiquier
  gtk_widget_queue_draw (Zone_dessin);

  // On désactive les boutons de retour en début de partie et recul si nécessaire
  if (g_position_courante_navigation == 1)
	{
		gtk_widget_set_sensitive (bouton_debut, FALSE);
		gtk_widget_set_sensitive (bouton_recul, FALSE);
	}

  // On active maintenant les 2 autres boutons de navigation
  gtk_widget_set_sensitive (bouton_avance, TRUE);
  gtk_widget_set_sensitive (bouton_dernier_coup, TRUE);

  // On interdit la possibilité de jouer un coup si la position
  // actuellement sélectionnée n'est pas la dernière.
  // On désactive le widget de l'échiquier
  gtk_widget_set_sensitive (Zone_dessin, FALSE);
			gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), FALSE);
}

void
gnavigation_avance (GtkButton * bouton, gpointer donnee)
{
  register gint z;
  GtkTreeIter iter;
	GtkWidget *cadre_partie;
	cadre_partie=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "cadre_partie"));
	GtkListStore *coup_affiche;
	coup_affiche=(GtkListStore*)
								(gtk_data_list_get_by_name(widget_list, "coup affiche"));
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *bouton_debut;
	bouton_debut=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton debut"));
	GtkWidget *bouton_recul;
	bouton_recul=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton recul"));
	GtkWidget *bouton_avance;
	bouton_avance=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton avance"));
	GtkWidget *bouton_dernier_coup;
	bouton_dernier_coup=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton dernier coup"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

  // On récupère l'iter actuellement pointé dans iter
  if (gtk_tree_selection_get_selected
      (gtk_tree_view_get_selection (GTK_TREE_VIEW (cadre_partie)), NULL, &iter))
	{
		// On va se placer maintenant une ligne après celle sélectionnée si elle
		// existe.
		if (g_position_courante_navigation < num_coup_joue)
		{
			if (g_position_courante_navigation % 2 == 0)
	    {
	      if (gtk_tree_model_iter_next(GTK_TREE_MODEL (coup_affiche), &iter))
				{
		  		gtk_tree_selection_select_iter (gtk_tree_view_get_selection
																					(GTK_TREE_VIEW(cadre_partie)), &iter);
		  		gtk_tree_view_set_cursor_on_cell (GTK_TREE_VIEW(cadre_partie),
						    gtk_tree_model_get_path(GTK_TREE_MODEL(coup_affiche), &iter),
						    																						NULL, NULL, FALSE);
				}
	    }
		}
	}

  // Il faut donner au tableaux des pièces et de l'échiquier
  // Les valeurs du coup suivant.
  for (z = 0; z < 33; z++)
	{
		table_piece[z] =
						tab_sauve_partie[g_position_courante_navigation].table_piece[z];
	}

  for (z = 0; z < 144; z++)
	{
		echiquier[z] =
						tab_sauve_partie[g_position_courante_navigation].echiquier[z];
	}

  if (g_position_courante_navigation != num_coup_joue)
    g_position_courante_navigation++;

  // On redessine l'échiquier
  gtk_widget_queue_draw (Zone_dessin);

  // On désactive les boutons de fin de partie et d'avance si nécessaire
  if (g_position_courante_navigation == num_coup_joue)
    {
      gtk_widget_set_sensitive (bouton_avance, FALSE);
      gtk_widget_set_sensitive (bouton_dernier_coup, FALSE);
      // On autorise de nouveau à jouer
      gtk_widget_set_sensitive (Zone_dessin, TRUE);
			gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), TRUE);
    }
  else
    {
      // On interdit la possibilité de jouer un coup si la position
      // actuellement sélectionnée n'est pas la dernière.
      // On désactive le widget de l'échiquier
      gtk_widget_set_sensitive (Zone_dessin, FALSE);
      			gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), FALSE);
    }

  // On active maintenant les 2 autres boutons de navigation
  gtk_widget_set_sensitive (bouton_debut, TRUE);
  gtk_widget_set_sensitive (bouton_recul, TRUE);
}

void
gnavigation_dernier_coup (GtkButton * bouton, gpointer donnee)
{
  register gint z;
  GtkTreeIter iter;
  GtkTreeIter iter_tmp;
	GtkWidget *cadre_partie;
	cadre_partie=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "cadre_partie"));
	GtkListStore *coup_affiche;
	coup_affiche=(GtkListStore*)
								(gtk_data_list_get_by_name(widget_list, "coup affiche"));
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *bouton_debut;
	bouton_debut=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton debut"));
	GtkWidget *bouton_recul;
	bouton_recul=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton recul"));
	GtkWidget *bouton_avance;
	bouton_avance=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton avance"));
	GtkWidget *bouton_dernier_coup;
	bouton_dernier_coup=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton dernier coup"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));

  // Il faut donner au tableaux des pièces et de l'échiquier
  // Les valeurs du dernier coup.
  for (z = 0; z < 33; z++)
    {
      table_piece[z] = tab_sauve_partie[num_coup_joue - 1].table_piece[z];
    }

  for (z = 0; z < 144; z++)
    {
      echiquier[z] = tab_sauve_partie[num_coup_joue - 1].echiquier[z];
    }
  // On redessine l'échiquier
  gtk_widget_queue_draw (Zone_dessin);

  // On désactive le bouton de retour en fin de partie puisque c'est fait!
  // ainsi que le bouton d'avance pas à pas.
  gtk_widget_set_sensitive (bouton_dernier_coup, FALSE);
  gtk_widget_set_sensitive (bouton_avance, FALSE);

  // On active maintenant les 2 autres boutons de navigation
  gtk_widget_set_sensitive (bouton_recul, TRUE);
  gtk_widget_set_sensitive (bouton_debut, TRUE);

  // Positionnement de l'ascenceur sur le dernier coup et sélection de celui-ci
  if (gtk_tree_model_get_iter_first (GTK_TREE_MODEL (coup_affiche), &iter))
    {
      // iter pointe sur la première ligne
      iter_tmp = iter;
      while (gtk_tree_model_iter_next
	     (GTK_TREE_MODEL (coup_affiche), &iter_tmp))
	iter = iter_tmp;
      gtk_tree_view_set_cursor_on_cell (GTK_TREE_VIEW (cadre_partie),
					gtk_tree_model_get_path
					(GTK_TREE_MODEL (coup_affiche),
					 &iter), NULL, NULL, FALSE);
      gtk_tree_selection_select_iter (gtk_tree_view_get_selection
				      (GTK_TREE_VIEW (cadre_partie)), &iter);
    }

  g_position_courante_navigation = num_coup_joue;

  // On autorise de nouveau à jouer puisque la position
  // actuellement sélectionnée est la dernière.
  gtk_widget_set_sensitive (Zone_dessin, TRUE);
	gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), TRUE);
}

gchar *
creation_affich_coups (gchar piece, gint couleur, gint position_initiale,
		       gint position_finale, gint type_deplacement)
{
  gchar *ligne_a_inserer = "";
  gchar *lettre_debut = "";
  gchar *lettre_fin = "";
  gchar *chiffre_debut = "";
  gchar *chiffre_fin = "";
  gchar *operation = "-";	// prise, déplacement, echec, roque. (- x + o-o O-O)
  gchar *piece_jouee = "";	// lettre de la pièce jouée
  gchar *echec = "";
  GtkTreeIter iter, iterfils;
	GtkWidget *cadre_partie;
	cadre_partie=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "cadre_partie"));
	GtkListStore *coup_affiche;
	coup_affiche=(GtkListStore*)
								(gtk_data_list_get_by_name(widget_list, "coup affiche"));

  if (type_deplacement == 1
      || type_deplacement == 5
      || type_deplacement == 6 || type_deplacement == 9)
    operation = "x";
  if (type_deplacement == 3)
    operation = "O-O";
  if (type_deplacement == 4)
    operation = "O-O-O";

  if ((le_roi_est_en_echec (blanc)) || (le_roi_est_en_echec (noir)))
    echec = "+";
  if (longueur_par_couleur_dans_liste (liste_coups_jouables, noir) == 0
      || longueur_par_couleur_dans_liste (liste_coups_jouables, blanc) == 0)
    echec = "#";

  if ((type_deplacement != 3) && (type_deplacement != 4))	// Si ce n'est pas un roque alors ...
    {
      if (echiquier[position_initiale].x == 1
	  && echiquier[position_finale].x == 1 && piece != pion)
	lettre_debut = "8";
      else if (echiquier[position_initiale].x == 1)
	lettre_debut = "a";

      if (echiquier[position_initiale].x == 2
	  && echiquier[position_finale].x == 2 && piece != pion)
	lettre_debut = "7";
      else if (echiquier[position_initiale].x == 2)
	lettre_debut = "b";

      if (echiquier[position_initiale].x == 3
	  && echiquier[position_finale].x == 3 && piece != pion)
	lettre_debut = "6";
      else if (echiquier[position_initiale].x == 3)
	lettre_debut = "c";

      if (echiquier[position_initiale].x == 4
	  && echiquier[position_finale].x == 4 && piece != pion)
	lettre_debut = "5";
      else if (echiquier[position_initiale].x == 4)
	lettre_debut = "d";

      if (echiquier[position_initiale].x == 5
	  && echiquier[position_finale].x == 5 && piece != pion)
	lettre_debut = "4";
      else if (echiquier[position_initiale].x == 5)
	lettre_debut = "e";

      if (echiquier[position_initiale].x == 6
	  && echiquier[position_finale].x == 6 && piece != pion)
	lettre_debut = "3";
      else if (echiquier[position_initiale].x == 6)
	lettre_debut = "f";

      if (echiquier[position_initiale].x == 7
	  && echiquier[position_finale].x == 7 && piece != pion)
	lettre_debut = "2";
      else if (echiquier[position_initiale].x == 7)
	lettre_debut = "g";

      if (echiquier[position_initiale].x == 8
	  && echiquier[position_finale].x == 8)
	lettre_debut = "1";
      else if (echiquier[position_initiale].x == 8)
	lettre_debut = "h";

      if (echiquier[position_finale].x == 1)
	lettre_fin = "a";
      if (echiquier[position_finale].x == 2)
	lettre_fin = "b";
      if (echiquier[position_finale].x == 3)
	lettre_fin = "c";
      if (echiquier[position_finale].x == 4)
	lettre_fin = "d";
      if (echiquier[position_finale].x == 5)
	lettre_fin = "e";
      if (echiquier[position_finale].x == 6)
	lettre_fin = "f";
      if (echiquier[position_finale].x == 7)
	lettre_fin = "g";
      if (echiquier[position_finale].x == 8)
	lettre_fin = "h";

      if (echiquier[position_initiale].y == 1)
	chiffre_debut = "1";
      if (echiquier[position_initiale].y == 2)
	chiffre_debut = "2";
      if (echiquier[position_initiale].y == 3)
	chiffre_debut = "3";
      if (echiquier[position_initiale].y == 4)
	chiffre_debut = "4";
      if (echiquier[position_initiale].y == 5)
	chiffre_debut = "5";
      if (echiquier[position_initiale].y == 6)
	chiffre_debut = "6";
      if (echiquier[position_initiale].y == 7)
	chiffre_debut = "7";
      if (echiquier[position_initiale].y == 8)
	chiffre_debut = "8";

      if (echiquier[position_finale].y == 1)
	chiffre_fin = "1";
      if (echiquier[position_finale].y == 2)
	chiffre_fin = "2";
      if (echiquier[position_finale].y == 3)
	chiffre_fin = "3";
      if (echiquier[position_finale].y == 4)
	chiffre_fin = "4";
      if (echiquier[position_finale].y == 5)
	chiffre_fin = "5";
      if (echiquier[position_finale].y == 6)
	chiffre_fin = "6";
      if (echiquier[position_finale].y == 7)
	chiffre_fin = "7";
      if (echiquier[position_finale].y == 8)
	chiffre_fin = "8";

      switch (piece)
	{
	case tour:
	  {
	    piece_jouee = "R";
	    break;
	  }
	case cavalier:
	  {
	    piece_jouee = "N";
	    break;
	  }
	case fou:
	  {
	    piece_jouee = "B";
	    break;
	  }
	case dame:
	  {
	    piece_jouee = "Q";
	    break;
	  }
	case roi:
	  {
	    piece_jouee = "K";
	  }
	}
      if (*operation != 'x')
	{
	  if (type_deplacement == 8)
	    ligne_a_inserer = g_strdup_printf ("%s8=Q", lettre_fin);
	  else
	    {
	      if (type_deplacement != 7)
		ligne_a_inserer =
		  g_strdup_printf ("%s%s%s%s", piece_jouee, lettre_fin,
				   chiffre_fin, echec);
	      else
		ligne_a_inserer =
		  g_strdup_printf ("%s%s%s%s%s", piece_jouee, lettre_debut,
				   lettre_fin, chiffre_fin, echec);
	    }
	}
      else
	{
	  if (piece != pion)
	    {
	      if (type_deplacement != 6 && type_deplacement != 7)
		ligne_a_inserer =
		  g_strdup_printf ("%s%s%s%s%s", piece_jouee, operation,
				   lettre_fin, chiffre_fin, echec);
	      else
		ligne_a_inserer =
		  g_strdup_printf ("%s%s%s%s%s%s", piece_jouee, lettre_debut,
				   operation, lettre_fin, chiffre_fin, echec);
	    }
	  else
	    {
	      if (type_deplacement == 9)
		{
		  ligne_a_inserer =
		    g_strdup_printf ("%s%s%s%s%s=Q%s", piece_jouee,
				     lettre_debut, operation, lettre_fin,
				     chiffre_fin, echec);
		}
	      else
		ligne_a_inserer =
		  g_strdup_printf ("%s%s%s%s%s%s", piece_jouee, lettre_debut,
				   operation, lettre_fin, chiffre_fin, echec);
	    }
	}
    }
  else
    ligne_a_inserer = g_strdup_printf ("%s", operation);

  if (couleur == blanche)
    {
      GtkTreePath *path;
      gtk_list_store_append (coup_affiche, &iter);
      gtk_list_store_set (coup_affiche, &iter, 0,
			  ((int) num_coup_joue / 2) + 1, 1, ligne_a_inserer,
			  2, " ", -1);

      // Positionnement de l'ascenseur sur le dernier coup joué
      // et sélection de la ligne correspondante au coup
      path = gtk_tree_model_get_path (GTK_TREE_MODEL (coup_affiche), &iter);
      gtk_tree_view_set_cursor_on_cell (GTK_TREE_VIEW (cadre_partie), path,
					NULL, NULL, FALSE);
      gtk_tree_path_free (path);

      // Permet l'affichage correcte de l'ascenseur en position inférieur
      while (gtk_events_pending ())
	gtk_main_iteration ();
    }
  else
    {
      gtk_tree_model_get_iter_first (GTK_TREE_MODEL (coup_affiche),
				     &iterfils);
      iter = iterfils;
      while (1)
	{
	  if (gtk_tree_model_iter_next
	      (GTK_TREE_MODEL (coup_affiche), &iterfils))
	    iter = iterfils;
	  else
	    break;
	}

      gtk_list_store_set (coup_affiche, &iter, 2, ligne_a_inserer, -1);
    }

  g_position_courante_navigation++;

  return ligne_a_inserer;
}
